// http://www.cepstrum.co.jp/
//
// fast FIR filter function test program
// use internal memory (DSP), near call
//
// opt. level of    1000tap FIR filter
// firfunc.c        execution clock      clock/sample
// --------------------------------------------------
// none             46400                46
// -o0 (register)   22200                22
// -o1 (local)      19200                19
// -o2 (function)    5300                 5

#define  FIR_LEN 1000

float    x, y;
float    fir_buf[2*FIR_LEN];
float    fir_coef[FIR_LEN];unsigned fir_ix;
unsigned temp;

float fast_fir(float, float[], float[], unsigned*, unsigned);

void main(void) {
  // initialize FIR filter
  for (temp=0; temp<FIR_LEN; temp=temp+1) {
    fir_coef[temp]=0.0;
    fir_buf[temp]=0.0;
    fir_buf[temp+FIR_LEN]=0.0;
  }
  y=fast_fir(x, fir_coef, fir_buf, &fir_ix, FIR_LEN);
}

